#include "ddplot.h"
#include "fformat.h"


// Return the format of file recognized from the file name.
int FFormat( QString fn )
{
  QString fname;
  FILE *f;
  double xcoor, ycoor, zcoor;
  int iswhat, nrel, atype, n, endc;
  bool isDD, isBOP, isPLT;

  fname = fn.lower();

  // internal format of the DDPlot program
  isDD = (fname.findRev(".dd") >= 0);

  // BOP block file with inert and active atoms
  isBOP = (fname.findRev(".bl") == fname.length()-3) || 
    (fname.findRev(".block") == fname.length()-6) ||
    (fname.findRev("block.interm") >=0 ) || 
    (fname.findRev("block.out") >=0 );

  if (isDD)   return FORMAT_DD;
  if (isBOP)  return FORMAT_BOP;

  //
  // We must open the file to determine if it contains the grain boundary data file
  //

  f = fopen(fn.ascii(),"r+");

  if (f==NULL)
    return FORMAT_UNKNOWN;

  fscanf(f, "%d\n", &nrel);
  for (n=0; n<nrel; n++)
    fscanf(f, "%lf\n", &zcoor);

  fscanf(f, "%lf %lf %d", &xcoor, &ycoor, &atype);
  endc = getc(f);
  if (endc!='\r' && endc!='\n' && endc!='\0') {  
    fclose(f);
    return FORMAT_GB;  // it is the grain boundary data file
  }

  fclose(f);
  return FORMAT_PLT;  // it is the plot file
}
